// Mod: Date Tips for Xin Calendar 2 (In-Page)
// Copyright 2004  Xin Yang    All Rights Reserved.

// Last Modified: 16-Dec-2005

// User interface
function addDateTips(confName,cssDateTip,cssDateTipDisabled,cssDateTipBoxTitle,cssDateTipBox,dateFormat,date,tip) {
  xcRegisterConf(confName,"dateTip",xcTransformDate(date,dateFormat||xcDateFormat,xcInternalDateFormat),[cssDateTip,cssDateTipDisabled,xcDateTipCount],0);
  xcDateTipPool[xcDateTipCount++]=[cssDateTipBox||xcCSSDateTipBox,tip,cssDateTipBoxTitle||xcCSSDateTipBoxTitle,date];
}

// Internal function
var xcDateTipCount=0, xcDateTipBox=null, xcDateTipTimer=0, xcDateTipPool=new Array();

function xcOverTipDate(cell,tipIdx) {
  var td=cell.parentElement?cell.parentElement:cell; // fix for IE/Mac
  clearTimeout(xcDateTipTimer);
  xcDateTipTimer=setTimeout("xcShowTip("+xcGetLayerX(td)+","+xcGetLayerY(td)+","+td.offsetWidth+","+td.offsetHeight+","+tipIdx+")",xcDateTipTiming);
}
function xcOutTipDate() {
  clearTimeout(xcDateTipTimer);
  xcDateTipTimer=setTimeout("xcHideTip()",xcDateTipTiming);
}
function xcOverTipBox() {
  clearTimeout(xcDateTipTimer);
}
function xcOutTipBox() {
  xcDateTipTimer=setTimeout("xcHideTip()",xcDateTipTiming);
}

function xcMakeTip(tipIdx) {
  if (xcDateTipBox==null) {
    xcDateTipBox=xcMakeLayer();
    xcDateTipBox.className=xcDateTipPool[tipIdx][0];

    if (xcIsIE55up && !xcIsMac) {
      xcDateTipBox.onmouseenter=xcOverTipBox;
      xcDateTipBox.onmouseleave=xcOutTipBox;
    }
    else {
      xcDateTipBox.onmouseover=xcOverTipBox;
      xcDateTipBox.onmouseout=xcOutTipBox;
    }

    xcDateTipBox.tipID=-1;
  }

  if (xcDateTipBox.tipID!=tipIdx) {
    xcDateTipBox.scrollTop=0;
    xcDateTipBox.scrollLeft=0;
    xcDateTipBox.innerHTML=(xcDateTipBoxTitleSwitch?xcDIV(xcDateTipPool[tipIdx][2],xcDateTipPool[tipIdx][3]):"")+xcDateTipPool[tipIdx][1];
  }
}

function xcShowTip(x,y,w,h,tipIdx) {
  xcMakeTip(tipIdx);

  if (xcDateTipBox.tipID!=tipIdx) {
    xcHideTip();

    var tipWidth=xcDateTipBox.offsetWidth, tipHeight=xcDateTipBox.offsetHeight;

    var dx=dy=0;
    if (xcDateTipBoxPosition==0 || xcDateTipBoxPosition==6) {
      dx=xcDateTipBoxAlign==0?0:xcDateTipBoxAlign==1?Math.floor((w-tipWidth)/2):(w-tipWidth);
      dy=xcDateTipBoxPosition==0?-tipHeight:h;
    }
    else {
      dx=xcDateTipBoxPosition==9?-tipWidth:w;
      dy=xcDateTipBoxValign==0?0:xcDateTipBoxValign==1?Math.floor((h-tipHeight)/2):(h-tipHeight);
    }
    dx+=xcDateTipBoxOffsetX; dy+=xcDateTipBoxOffsetY;

    if (xcDateTipBox.iframe) {
      xcDateTipBox.iframe.style.width=xcDateTipBox.offsetWidth+"px";
      xcDateTipBox.iframe.style.height=xcDateTipBox.offsetHeight+"px";

      xcDateTipBox.iframe.style.zIndex=xcDateTipBox.style.zIndex-1;
      xcMoveLayerTo(xcDateTipBox.iframe,x+dx,y+dy);
    }

    xcDateTipBox.style.zIndex=++xcBaseZIndex;
    xcMoveLayerTo(xcDateTipBox,x+dx,y+dy);

    if (xcDateTipBox.iframe) {
      xcShowLayer(xcDateTipBox.iframe);
    }

    if (xcIsIE && !xcIsMac && typeof(xcDateTipBox.filters)!="undefined" && typeof(xcDateTipBox.filters)!="unknown" && xcDateTipBox.filters.length>0) {
      for (var i=0; i<xcDateTipBox.filters.length; i++) {
        try { xcDateTipBox.filters[i].Apply(); } catch (err) {}
      }
    }

    xcShowLayer(xcDateTipBox);

    if (xcIsIE && !xcIsMac && typeof(xcDateTipBox.filters)!="undefined" && typeof(xcDateTipBox.filters)!="unknown" && xcDateTipBox.filters.length>0) {
      for (var i=0; i<xcDateTipBox.filters.length; i++) {
        try { xcDateTipBox.filters[i].Play(); } catch (err) {}
      }
    }

    xcDateTipBox.tipID=tipIdx;
  }
}

function xcHideTip() {
  if (xcDateTipBox) {
    if (xcDateTipBox.iframe) { xcMoveLayerTo(xcDateTipBox.iframe,-1000,-1000); }
    xcMoveLayerTo(xcDateTipBox,-1000,-1000);

    if (xcDateTipBox.iframe) { xcHideLayer(xcDateTipBox.iframe); }
    xcHideLayer(xcDateTipBox);

    xcDateTipBox.tipID=-1;
  }
}

// Overloaded functions
function xcMouseOverEvent() {
  var hasTip=xcDateTips(this);
  return hasTip?("xcOverTipDate(this,"+hasTip[2]+");"):"";
}
function xcMouseOutEvent() {
  var hasTip=xcDateTips(this);
  return hasTip?("xcOutTipDate();"):"";
}

function xcAfterUpdate(date) {
  clearTimeout(xcDateTipTimer);
  xcHideTip();

  afterSetDateValue(this.refField,this.targetField,date,this.idx);
}

// Mod function
function xcDateTips(cal) {
  return cal.getConf("dateTip",cal.date);
}

xcSpecialCalls[xcSpecialCalls.length]=xcDateTips;
